#include "DxLib.h"
#include <fstream>

#define PI	3.1415926535897932384626433832795f

// O[oϐ>_<
int gPacman[10];			// pbN}̃OtBbNnh
int gMapChip[10];			// }bv`bṽnh
int gMap[30][32];			// }bvf[^

// 摜̓ǂݍ
int LoadData()
{
// 摜̓ǂݍ
	if(LoadDivGraph("pacman.bmp",10, 10, 1, 48, 48, gPacman)==-1) {
		MessageBox(NULL,"pacman.bmp","ReadError",MB_OK);
		return -1;
	}
	if(LoadDivGraph("mapchip1.bmp", 5, 5, 1, 16, 16, gMapChip)==-1) {
		MessageBox(NULL,"mapchip1.bmp","ReadError",MB_OK);
		return -1;
	}

	return 0;
}

// }bv̓ǂݍ
int MapInit()
{
	int FileHandle = FileRead_open("StageData.txt");		// t@C̃I[v
	int FileSize = FileRead_size("StageData.txt");			// t@CTCY擾
	char* FileImage = new char[FileSize];					// ̑傫̈m
	FileRead_read( FileImage,FileSize,FileHandle);			// Cǂ
	FileRead_close(FileHandle);								// t@CďI

	const char* d = FileImage;
	int sx=0,sy=0;
	int o;

	while(*d != '\0'){ // NULLiI[jł͂Ȃ
		switch( *d ){
			case ' ':	o = 0; break;
			case 'o':	o = 1; break;
			case '@':	o = 2; break;
			case '#':	o = 3; break;
			case '=':	o = 4; break;
			case '\n':
				sy ++;		// sցA[
				sx = 0;		// throw down
			default:	o = 5; break;
		}
		d++;
		if( o != 5 ){
			gMap[sy][sx]=o;	// }bv񏑂
			sx++;
		}
	}
	return 0;
}

// 
int Init()
{
	ChangeWindowMode(TRUE);
	if(DxLib_Init() == -1) return -1;

	SetDrawScreen( DX_SCREEN_BACK);		// ʂɏ݂܂錾

	if(LoadData()==-1) {
		DxLib_End();
		return -1;
	}
	MapInit();
	return 0;
}
int MapSet()
{
	int sx,sy,st;
	int dot = 0;

	for(sy=0;sy<30;sy++){
		for(sx=0;sx<32;sx++){
			st = gMap[sy][sx];
			DrawGraph(sx*16,sy*16,gMapChip[st],TRUE);
			if(st == 1 || st == 2) dot++; 
		}
	}
	if( dot == 0 ){		// ĤׂcĂȂ
//		ClearEvent();	// NAłA炢˂撣˂
		return -1;
	}
	return 0;
}

// C[v
void MainLoop()
{
	int key;
	int s = 0;
	int x=200, y=200;
	int dx = -4, dy = 0;
	float Angle = 0.0f;	// @
	while(ProcessMessage()==0){
		ClsDrawScreen();
		if(MapSet()==-1)return;
		key = GetJoypadInputState( DX_INPUT_KEY_PAD1 );
		if(key & PAD_INPUT_START) break;		// PAD_INPUT_START  [ESC]Key

		if(x<=0+48 || x>=640-48 || y<=0+48 || y>=480-48) {	// ʂ̒[̂قmF
															// [߂ł̓L[͎󂯕tȂ
			if(x<=0+24 || x>=640-24 || y<=0+24 || y>=480-24) {	// ʂ̒[mF
				dx *= -1; 
				dy *= -1;									// []
				Angle += PI;								// isPI(180x)Z
				if(Angle > 2*PI) Angle -= 2*PI;				// 360xȏȂ360xB
			}												// 270xł-90xłΉĂ̂ŁÃ[YɊÂB
		} else {
			if(key & PAD_INPUT_UP)	 { dx =  0; dy = -4; Angle = PI / 2;}
			if(key & PAD_INPUT_DOWN) { dx =  0; dy =  4; Angle = -PI / 2;}
			if(key & PAD_INPUT_LEFT) { dx = -4; dy =  0; Angle = 0;}
			if(key & PAD_INPUT_RIGHT){ dx =  4; dy =  0; Angle = PI;}
		}
		x+=dx;
		y+=dy;
		s = (++s)%7;

		DrawRotaGraph(x, y, 1, Angle, gPacman[s], TRUE);
		ScreenFlip();
	}
	return;
}

int WINAPI WinMain(HINSTANCE hI,HINSTANCE hP, LPSTR lpC, int nC)
{
	if(Init()) return -1;	// 

	MainLoop();				// C[`

	DxLib_End();			// Ƃ܂
	return 0;
}